Summary: Leading World Wide Web server
Name: apache
%define version 1.3.3
Version: %{version}
Release: 1
Group: Networking/Daemons

Source: ftp://ftp.apache.org/apache/dist/apache_%{version}.tar.gz
Source1: apache-index.html
Source2: poweredby.gif
Source3: httpd.init
Source4: apache.log
Source5: apache-access.conf
Source6: apache-httpd.conf
Source7: apache-srm.conf

Patch0: apache_%{version}-redhat.patch
Patch1: apache_%{version}-apxs.patch
Patch2: apache_1.3.1-srvroot.patch

Copyright: Freely distributable and usable
BuildRoot: /var/tmp/apache-root
Requires: /etc/mime.types
Prereq: /sbin/chkconfig, /bin/mktemp
Provides: webserver
Summary(de): Leading World Wide Web-Server
Summary(fr): Serveur Web leader du march<E9>
Summary(tr): Lider WWW taray<FD>c<FD>

%description
Apache is a full featured web server that is freely available, and also
happens to be the most widely used.

%description -l de
Apache ist ein voll funktionsf<E4>higer Web-Server, der kostenlos
erh<E4>ltlich und weit verbreitet ist.

%description -l fr
Apache est un serveur Web complet, disponible librement, et se trouve <EA>tre
aussi le plus utilis<E9> <E0> travers le monde.

%description -l tr
Apache serbest da<F0><FD>t<FD>lan ve <E7>ok kullan<FD>lan yetenekli bir web sunucusudur.

%package devel
Group: Networking/Daemons
Summary: Header files from apache for developing/compiling 3rd party modules
Obsoletes: secureweb-devel

%description devel
This package includes the source code and for Apache 1.3.1, as well as the
'apxs' binary for building dynamic shared objects (DSOs).  This package needs
to be installed if you want to compile or develop additional modules for
Apache.

%prep
# first, unpack apache.  We unpack it BELOW a toplevel directory "secureweb"
%setup -q -n apache_%{version}
%patch0 -p1 -b .redhat
%patch1 -p1 -b .apxs
%patch2 -p1 -b .srvroot

%build
OPTIM="$RPM_OPT_FLAGS" \
	./configure --prefix=/usr \
	--libexecdir=/usr/lib/apache \
	--sysconfdir=/etc/httpd/conf \
	--serverroot=/etc/httpd \
	--datadir=/home/httpd \
	--includedir=/usr/include/apache \
	--logfiledir=/var/log/httpd \
	--localstatedir=/var \
	--runtimedir=/var/run \
	--proxycachedir=/var/cache/httpd \
	--enable-module=all \
	--enable-shared=max \
	--disable-rule=WANTHSREGEX
make
	
%install
rm -rf $RPM_BUILD_ROOT
make install root=$RPM_BUILD_ROOT

# remove apachectl; we have our own SYSV init stuff
rm $RPM_BUILD_ROOT/usr/sbin/apachectl

# rename the html directory
mv $RPM_BUILD_ROOT/home/httpd/htdocs $RPM_BUILD_ROOT/home/httpd/html

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/httpd.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

for I in 0 1 2 6; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/K15httpd
done
for I in 3 5; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/S85httpd
done

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/apache.log \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache

ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../../usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules

install -m644 $RPM_SOURCE_DIR/apache-index.html \
        $RPM_BUILD_ROOT/home/httpd/html/index.html
install -m644 $RPM_SOURCE_DIR/poweredby.gif \
	$RPM_BUILD_ROOT/home/httpd/html

# replace Apache's default config files with our own versions
install -m644 $RPM_SOURCE_DIR/apache-access.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/access.conf

install -m644 $RPM_SOURCE_DIR/apache-httpd.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

install -m644 $RPM_SOURCE_DIR/apache-srm.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/srm.conf

# install apache source code for devel package
#mkdir -p $RPM_BUILD_ROOT/usr/src
#tar xzf $RPM_SOURCE_DIR/apache_%{version}.tar.gz -C $RPM_BUILD_ROOT/usr/src
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add httpd
[ -f /etc/mime.types ] || exit 0
# safely add .htm to mime types if it is not already there
TEMPTYPES=`/bin/mktemp /tmp/mimetypes.XXXXXX`
[ -z "$TEMPTYPES" ] && {
  echo "could not make temporary file, htm not added to /etc/mime.types" >&2
  exit 1
}
( grep -v "^text/html"  /etc/mime.types
  types=$(grep "^text/html" /etc/mime.types | cut -f2-)
  echo -en "text/html\t\t\t"
  for val in $types ; do
      if [ "$val" = "htm" ] ; then
          continue
      fi
      echo -n "$val "
  done
  echo "htm"
) > $TEMPTYPES
cat $TEMPTYPES > /etc/mime.types && rm -f $TEMPTYPES

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del httpd
fi

%files
%defattr(-,root,root)
%dir /etc/httpd/conf
%config /etc/httpd/conf/access.conf
%config /etc/httpd/conf/srm.conf
%config /etc/httpd/conf/httpd.conf
%config /etc/httpd/conf/magic

/etc/httpd/logs
/etc/httpd/modules
%config /etc/logrotate.d/apache
%config /etc/rc.d/init.d/httpd
%config(missingok) /etc/rc.d/rc3.d/S85httpd
%config(missingok) /etc/rc.d/rc5.d/S85httpd
%config(missingok) /etc/rc.d/rc0.d/K15httpd
%config(missingok) /etc/rc.d/rc1.d/K15httpd
%config(missingok) /etc/rc.d/rc2.d/K15httpd
%config(missingok) /etc/rc.d/rc6.d/K15httpd

%dir /home/httpd
%dir /home/httpd/cgi-bin
%dir /home/httpd/html
%config(noreplace) /home/httpd/html/index.html
/home/httpd/html/poweredby.gif
/home/httpd/html/manual
/home/httpd/icons

/usr/lib/apache
/usr/man/*/*
/usr/sbin/ab
/usr/sbin/httpd
/usr/sbin/logresolve
/usr/sbin/rotatelogs
/usr/bin/*

%attr(-,nobody,nobody) %dir /var/cache/httpd
%dir /var/log/httpd

%files devel
%defattr(-,root,root)
/usr/include/apache
/usr/sbin/apxs
#/usr/src/apache_%{version}

%changelog
* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.3.3 to catch up with bug fixes
- added the /usr/bin/* binaries to the spec file list

* Fri Sep 25 1998 Cristian Gafton <gafton@redhat.com>
- change ownership of cache dir to nobody
- added "Red Hat" to the server string
- updated to version 1.3.2
- fixed all references to httpsd in config files

* Fri Sep 04 1998 Cristian Gafton <gafton@redhat.com>
- small fixes to the spec file
- patch to handle correctly the -d <newroot> option
- leave out the .usr.src.apache_%{version} for now

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- patched apxs not to bomb out if it can't find httpd

* Wed Sep 02 1998 Preston Brown <pbrown@redhat.com>
- upgraded to apache 1.3.1.
- Heavy rewrite.
- changed providing a_web_server to just webserver.  Humor is not an option.

* Mon Aug 10 1998 Erik Troan <ewt@redhat.com>
- updated to build as non-root user
- added patch to defeat header dos attack

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- fixed the default config files to be more paranoid about security

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed init script
- added index.htm to the list of acceptable indexes

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.2.6
- added post script to install htm extension for text/html into
  /etc/mime.types

* Wed Apr 22 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced sysv init script

* Tue Jan 06 1998 Erik Troan <ewt@redhat.com>
- updated to 1.2.5, which includes many security fixes

* Wed Dec 31 1997 Otto Hammersmith <otto@redhat.com>
- fixed overkill on http.init stop

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>
- added patch for backslash DOS attach

* Thu Nov 06 1997 Donnie Barnes <djb@redhat.com>
- added htdigest binary to file list

* Mon Nov 03 1997 Donnie Barnes <djb@redhat.com>
- made the default index.html be config(noreplace) so we no longer
  blow away other folks' index.html

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added chkconfig support
- added restart|status options to initscript
- renamed httpd.init to httpd

* Tue Oct 07 1997 Elliot Lee <sopwith@redhat.com>
- Redid spec file, patches, etc. from scratch.
